def biuni(x)
  return (x + 1) * 0.5
end

def unilin(x, l, r)
  return x * (r - l) + l
end

def bilin(x, l, r)
  return unilin(biuni(x), l, r)
end

def linlin(x, l0, r0, l1, r1)
  return unilin((x - l0) / (r0 - l0), l1, r1)
end

root = 4
bar = 4*(128.0/240.0)

define :amb do |singrain_fade_t:, basspad_fade_start:, basspad_fade_t:|
  with_fx :gverb, dry: 0, room: 16, pre_amp: 0.26, mix: 0.3, spread: 0.8, damp: 0.1 do |vb|
    with_fx :rlpf do |fil|
      with_fx :bitcrusher do |bit|
        t = 0
        live_loop :singrain do
          fade = [t, singrain_fade_t].min / singrain_fade_t
          control bit, sample_rate: rrand(3000,7000)
          control fil, cutoff: bilin(Math::sin(t*0.6), 80, 100)*fade**0.25, res: 0.5
          use_synth :sine
          l = rrand(0.05,0.3)
          w = rrand(0.0,1.0)
          play choose([0,4,7,11,12,16]) + 48 + choose([0, 12, 24]) + root, attack: l*w, decay: 0, sustain: 0, release: l-l*w,
            amp: rrand(0.4,0.6)*0.5*fade**3, pan: rrand(-1,1)
          dt = linlin((rrand(0.0,1.0)**4), 0, 1, 0.04,0.1)
          sleep dt
          t += dt
        end
      end
    end
  end
  
  with_fx :normaliser do |norm|
    with_fx :rlpf do |fil|
      t = 0
      live_loop :basspad do
        fade = [[0,t-basspad_fade_start].max, basspad_fade_t].min / basspad_fade_t
        control fil, cutoff: rrand(50, 80), res: 0.2, cutoff_slide: 0.2, cutoff_slide_shape: 2
        control norm, level: (0.00001+fade)**3*0.5, level_slide: 0.2, level_slide_shape: 2
        use_synth :saw
        play 24 + rrand(-1,1)*0.06 + root, attack: 0.3, release: 0.3, pan: rrand(-0.5,0.5)
        dt = rrand(0.1,0.2)
        sleep dt
        t += dt
      end
    end
  end
end

define :belody do |start:|
  note = [0,7,4,-3,0,-5,-7].ring
  oct = [0,0,1,0,0].ring
  dur = [4,4,2,2,3.0/2,3.0/2,1,2,2].ring
  i = 0
  with_fx :echo, phase: bar*3.01/16, decay: 10, mix: 0.4 do
    with_fx :hpf, cutoff: 70 do
      live_loop :bell do
        if i == 0
          sleep start
        end
        use_synth :kalimba
        play note[i] + oct[i]*12 + 60 + root, release: 2, amp: 5.3, pan: rrand(-0.6,0.6), clickiness: rrand(0.2, 0.3)
        sleep (bar*dur[i]/8.0)
        i += 1
      end
    end
  end
end

define :kick do |start:|
  dur = [3,3,2, 3,3,2, 3,3,2, 3,2,1,2].ring
  i = 0
  live_loop :kick do
    if i == 0
      sleep start
    end
    sample :bd_tek, amp: 1.3
    sleep bar*dur[i]/16.0
    i += 1
  end
end

define :hat do |start:|
  dur = [1].ring
  samps = [:hat_hier, :hat_gnu, :hat_mess, :hat_star, :hat_yosh]
  off = [0,0,0,5,4,2,3,4,5,0,1,2,2].ring
  pan = [-1,0.5,0,1,-0.5,0].ring
  i = 0
  t = 0
  live_loop :hat do
    if i == 0
      sleep start
    end
    sample samps[(i + off[i]) % samps.length], amp: 0.9, release: 0.1, pan: pan[i]*0.6
    dt = bar*dur[i]/16.0
    sleep dt
    i += 1
    t += dt
  end
end

define :brk do |start:, speeds:, chopses:, offset:|
  i = 0
  with_fx :hpf, cutoff: 45 do
    live_loop :brk do
      if i == 0
        sleep start
      end
      speed = speeds[i]
      rate = speed.abs * (sample_duration :loop_amen_full)/(4*bar)
      chops = chopses[i]
      sta = ((0.0+i) % chops) / chops + (0.0+chops+offset[i])/chops
      sta = sta % 1.0
      len = 1.0/chops
      len -= 0.003
      fin = sta+len
      if speed < 0
        tmp = sta
        sta = fin
        fin = tmp
      end
      sample :loop_amen_full, rate: rate, amp: 1.15, start: sta, finish: fin
      sleep 4*bar/(speed.abs*chops)
      i += 1
    end
  end
end

define :pad do |start:|
  with_fx :hpf, cutoff: 70 do
    dur = [4].ring
    chrd = [[0,7,4], [-3,9,5]].ring
    i = 0
    live_loop :pad do
      if i == 0
        sleep start
      end
      use_synth :hollow
      chrd[i].each_with_index.map { |n,i| play n + 72 + root, attack: bar, release: bar*2, amp: 2, pan: linlin(i, 0, 2, -1.0, 1.0)*0.6 }
      sleep bar*dur[i]
      i += 1
    end
  end
end

define :mel do |start:, fade_b:|
  with_fx :echo, phase: 2.0/32*bar, mix: 0.3, decay: 6 do
    with_fx :tanh, krunch: 3, amp: 1.15 do
      dur = [3,2,3,1,1,3,2,1,1,1,2,2].ring
      note = [
        [19,16,11,12,7].ring, [17,12,7,9,5].ring,
        [19,16,11,12,7].ring, [21,17,9,12,5].ring
      ].ring
      oct = [-1,-2,0,-1].ring
      off = [0,0,0,0,0,0,0,0,0,-2,-1].ring
      i = 0
      b = 0
      live_loop :mel do
        if i == 0
          sleep start
        end
        fade = [b, fade_b].min / fade_b
        use_synth :blade
        play note[(b/4).floor][i+off[i]] + oct[i]*12 + 60 + root, release: rrand(0.1,0.3), pan: rrand(-1.0,1.0)*0.3, amp: 1.0 * fade**4
        db = dur[i]/16.0
        sleep bar*db
        i += 1
        b += db
      end
    end
  end
end

define :roll do |start:|
  div = 32
  n = 2*div
  i = 0
  live_loop :roll do
    if i == 0
      sleep start
    elsif i == n
      stop
    end
    k = (0.0+i)/n
    sample :sn_dub, sustain: 0.1, release: 0.001, amp: k*1.5, rate: unilin(k**2, 1.0, 1.5)
    sleep bar/div
    i += 1
  end
end

define :crash do |start:|
  live_loop :crash do
    sleep start
    sample :drum_cymbal_open, amp: 1.2, rate: 0.9
    stop
  end
end

belody_start = 31
beet_start = belody_start + 16*bar
pad_start = beet_start + 8*bar
brk_start = pad_start + 16*bar
stop_phase = 3.0/16*bar
all_stop0 = brk_start + 16*bar
all_stop1 = all_stop0 + stop_phase
roll_start = all_stop0 - 2*bar

with_fx :level, amp: 0.7 do |mlvl|
  with_fx :hpf, cutoff: 60, mix: 0 do |mfil|
    with_fx :ping_pong, phase: stop_phase, feedback: 0.8, pan_start: -0.5, decay: 10, pre_mix: 0, mix: 0 do |mecho|
      with_fx :level, amp: 1.0 do |blvl|
        amb(singrain_fade_t: 5, basspad_fade_start: 15, basspad_fade_t: 10)
        #amb(singrain_fade_t: 0.1, basspad_fade_start: 0, basspad_fade_t: 0.1)
        belody(start: belody_start)
        kick(start: beet_start)
        hat(start: beet_start)
        pad(start: pad_start)
        mel(start: pad_start, fade_b: 4)
        brk(start: brk_start, speeds: [2].ring, chopses: [16,16,8,8,32,32,4,64,64,64,64,8,16,8,16,8,8].ring, offset: [0,0,15,14,11,4,8,11,0,1,3,0,4,9,7,12,10,0,5,4,3,2,0,1,0,1].ring)
        roll(start: roll_start)
        crash(start: all_stop0)
        
        sleep all_stop0
        control mecho, pre_mix: 1
        sleep all_stop1 - all_stop0
        control blvl, amp: 0
        control mecho, mix: 1
        control mfil, mix: 1
      end
    end
  end
end

